﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ПервоначальноеРаспределениеПоСЗ
{
    public class Decision // Решение
    {
        public string[,] matrxD; //Матрица которая хранит таблицу, где будет хранится распределение
        public int r = 0, c = 0; //размерности матрицы и векторов
        public static string[] DebugIndex; // Переменная для вывода в отладочное окно информации
        public static int GetDistribution(ref string[,] a) //Выполнения распредления и подсчёта суммы
        {
            DebugIndex = new string[0];
            int summa = 0; // Переменная для хранения суммы
            for (int i = 1; i < a.GetLength(0); i++) // Цикл по строкам массива
            {
                for (int j = 1; j < a.GetLength(1); j++) // Цикл по столбцам массива
                {
                    if (Convert.ToInt32(a[0, j]) != 0) // Проверка, если в ячейке спрос равен 0, то идём дальше
                    {
                        if (Convert.ToInt32(a[i, 0]) != 0) // Проверка, если в ячейке предложение равно 0, то переходим на новую строчку
                        {
                            Array.Resize(ref DebugIndex, DebugIndex.Length + 1);
                            DebugIndex[DebugIndex.Length - 1] = i + ";" + j;
                            if (Convert.ToInt32(a[i, 0]) > Convert.ToInt32(a[0, j])) // Проверка, если предложение больше спроса
                            {
                                summa = summa + Convert.ToInt32(a[i, j]) * Convert.ToInt32(a[0, j]); // К сумме прибавляем произведение цены с поставкой
                                a[i, j] = a[i, j] + " | " + a[0, j]; // В ячекй добавляем символ / и максимальную поставку
                                a[i, 0] = Convert.ToString(Convert.ToInt32(a[i, 0]) - Convert.ToInt32(a[0, j])); // Вычитаем из предложения сделанную поставку
                                a[0, j] = "0"; // Зануляем спрос, так как весь спрос удовлетворён
                            }
                            else if (Convert.ToInt32(a[i, 0]) < Convert.ToInt32(a[0, j]))// Проверка, если предложение меньше спроса
                            {
                                summa = summa + (Convert.ToInt32(a[i, j]) * Convert.ToInt32(a[i, 0])); // К сумме прибавляем произведение цены с поставкой
                                a[i, j] = a[i, j] + " | " + a[i, 0]; // В ячекй добавляем символ / и максимальную поставку
                                a[0, j] = Convert.ToString(Convert.ToInt32(a[0, j]) - Convert.ToInt32(a[i, 0])); // Вычитаем из спроса сделанную поставку
                                a[i, 0] = "0"; // Зануляем предложение, так как у данного поставщика закончилась продукция
                                // Переходим на новую строку на тот же магазин
                                if (i != i - 1)
                                {
                                    i++;
                                    j--;
                                }
                            }
                            else
                            {
                                summa = summa + (Convert.ToInt32(a[i, j]) * Convert.ToInt32(a[i, 0])); // К сумме прибавляем произведение цены с поставкой
                                a[i, j] = a[i, j] + " | " + a[i, 0]; // В ячекй добавляем символ / и максимальную поставку
                                a[i, 0] = "0"; // Зануляем предложение, так как у данного поставщика закончилась продукция
                                a[0, j] = "0"; // Зануляем спрос, так как весь спрос удовлетворён
                                // Переходим на новую строку на тот же магазин
                                if (i != i - 1)
                                {
                                    i++;
                                    j--;
                                }
                            }
                        }
                        else
                        {
                            i++;
                        }
                    }
                }
            }
            return summa;
        }
    }
}
